// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/AccelerationControl.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__SIZE_BITS = 7
};

/// Constant 'BIT_INDEX_BRAKE_PEDAL_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_BRAKE_PEDAL_ENGAGED = 0
};

/// Constant 'BIT_INDEX_GAS_PEDAL_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_GAS_PEDAL_ENGAGED = 1
};

/// Constant 'BIT_INDEX_EMERGENCY_BRAKE_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_EMERGENCY_BRAKE_ENGAGED = 2
};

/// Constant 'BIT_INDEX_COLLISION_WARNING_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_COLLISION_WARNING_ENGAGED = 3
};

/// Constant 'BIT_INDEX_ACC_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_ACC_ENGAGED = 4
};

/// Constant 'BIT_INDEX_CRUISE_CONTROL_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_CRUISE_CONTROL_ENGAGED = 5
};

/// Constant 'BIT_INDEX_SPEED_LIMITER_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl__BIT_INDEX_SPEED_LIMITER_ENGAGED = 6
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/AccelerationControl in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__AccelerationControl
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the current controlling mechanism for longitudinal movement of the vehicle.
  ///  * The data may be provided via the in-vehicle network. It indicates whether a specific in-vehicle
  ///  * acceleration control system is engaged or not. Currently, this DE includes the information of the
  ///  * vehicle brake pedal, gas pedal, emergency brake system, collision warning system, adaptive cruise
  ///  * control system, cruise control system and speed limiter system.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 - `brakePedalEngaged`      - Driver is stepping on the brake pedal,
  ///  * - 1 - `gasPedalEngaged`        - Driver is stepping on the gas pedal,
  ///  * - 2 - `emergencyBrakeEngaged`  - emergency brake system is engaged,
  ///  * - 3 - `collisionWarningEngaged`- collision warning system is engaged,
  ///  * - 4 - `accEngaged`             - ACC is engaged,
  ///  * - 5 - `cruiseControlEngaged`   - cruise control is engaged,
  ///  * - 6 - `speedLimiterEngaged`    - speed limiter is engaged.
  ///  *
  ///  * Otherwise (for example when the corresponding system is not available due to non equipped system
  ///  * or information is unavailable), the corresponding bit shall be set to 0.
  ///  *
  ///  * @note: The system engagement condition is OEM specific and therefore out of scope of the present document.
  ///  * @category: Vehicle information
  ///  * @revision: V1.3.1
  ///  */
  /// AccelerationControl ::= BIT STRING {
  ///     brakePedalEngaged       (0),
  ///     gasPedalEngaged         (1),
  ///     emergencyBrakeEngaged   (2),
  ///     collisionWarningEngaged (3),
  ///     accEngaged              (4),
  ///     cruiseControlEngaged    (5),
  ///     speedLimiterEngaged     (6)
  /// } (SIZE(7))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cam_ts_msgs__msg__AccelerationControl;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__AccelerationControl.
typedef struct etsi_its_cam_ts_msgs__msg__AccelerationControl__Sequence
{
  etsi_its_cam_ts_msgs__msg__AccelerationControl * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__AccelerationControl__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__STRUCT_H_
