// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/AccidentSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'MULTI_VEHICLE_ACCIDENT'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__MULTI_VEHICLE_ACCIDENT = 1
};

/// Constant 'HEAVY_ACCIDENT'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__HEAVY_ACCIDENT = 2
};

/// Constant 'ACCIDENT_INVOLVING_LORRY'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__ACCIDENT_INVOLVING_LORRY = 3
};

/// Constant 'ACCIDENT_INVOLVING_BUS'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__ACCIDENT_INVOLVING_BUS = 4
};

/// Constant 'ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS = 5
};

/// Constant 'ACCIDENT_ON_OPPOSITE_LANE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__ACCIDENT_ON_OPPOSITE_LANE = 6
};

/// Constant 'UNSECURED_ACCIDENT'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__UNSECURED_ACCIDENT = 7
};

/// Constant 'ASSISTANCE_REQUESTED'.
enum
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__ASSISTANCE_REQUESTED = 8
};

/// Struct defined in msg/AccidentSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause code of the @ref CauseCode `accident`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `unavailable`                        - in case the information on the sub cause of the accident is unavailable,
  ///  * - 1 - `multiVehicleAccident`               - in case more than two vehicles are involved in accident,
  ///  * - 2 - `heavyAccident`                      - in case the airbag of the vehicle involved in the accident is triggered,
  ///  *                                              the accident requires important rescue and/or recovery work,
  ///  * - 3 - `accidentInvolvingLorry`             - in case the accident involves a lorry,
  ///  * - 4 - `accidentInvolvingBus`               - in case the accident involves a bus,
  ///  * - 5 - `accidentInvolvingHazardousMaterials`- in case the accident involves hazardous material,
  ///  * - 6 - `accidentOnOppositeLane`             - in case the accident happens on opposite lanes,
  ///  * - 7 - `unsecuredAccident`                  - in case the accident is not secured,
  ///  * - 8 - `assistanceRequested`                - in case rescue and assistance are requested,
  ///  * - 9-255                                    - reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// AccidentSubCauseCode ::= INTEGER {
  ///     unavailable                         (0),
  ///     multiVehicleAccident                (1),
  ///     heavyAccident                       (2),
  ///     accidentInvolvingLorry              (3),
  ///     accidentInvolvingBus                (4),
  ///     accidentInvolvingHazardousMaterials (5),
  ///     accidentOnOppositeLane              (6),
  ///     unsecuredAccident                   (7),
  ///     assistanceRequested                 (8)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_H_
