// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/BasicVehicleContainerHighFrequency.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'heading'
#include "etsi_its_cam_ts_msgs/msg/detail/heading__struct.h"
// Member 'speed'
#include "etsi_its_cam_ts_msgs/msg/detail/speed__struct.h"
// Member 'drive_direction'
#include "etsi_its_cam_ts_msgs/msg/detail/drive_direction__struct.h"
// Member 'vehicle_length'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length__struct.h"
// Member 'vehicle_width'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_width__struct.h"
// Member 'longitudinal_acceleration'
// Member 'lateral_acceleration'
// Member 'vertical_acceleration'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_component__struct.h"
// Member 'curvature'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature__struct.h"
// Member 'curvature_calculation_mode'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature_calculation_mode__struct.h"
// Member 'yaw_rate'
#include "etsi_its_cam_ts_msgs/msg/detail/yaw_rate__struct.h"
// Member 'acceleration_control'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_control__struct.h"
// Member 'lane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.h"
// Member 'steering_wheel_angle'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle__struct.h"
// Member 'performance_class'
#include "etsi_its_cam_ts_msgs/msg/detail/performance_class__struct.h"
// Member 'cen_dsrc_tolling_zone'
#include "etsi_its_cam_ts_msgs/msg/detail/cen_dsrc_tolling_zone__struct.h"

/// Struct defined in msg/BasicVehicleContainerHighFrequency in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  /// * This type contains detaild information of the Basic Vehicle Container High Frequency.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field heading: It represent the heading and heading accuracy of the vehicle movement of the originating ITS-S with regards to the true north.
  /// * The heading accuracy provided in the heading Confidence value shall provide the accuracy of the measured vehicle heading with a confidence level
  /// * of 95 %. Otherwise, the value of the headingConfidence shall be set to unavailable.
  /// *
  /// * @field speed: It represent driving speed and speed accuracy of the originating ITS-S. The speed accuracy provided in the speedConfidence shall
  /// * provide the accuracy of the speed value with a confidence level of 95 %. Otherwise, the speedConfidence shall be set to unavailable.
  /// *
  /// * @field driveDirection: This component represent the vehicle drive direction (forward or backward) of the originating ITS-S.
  /// *
  /// * @field vehicleLength: This component represent the vehicle length value and vehicle length confidence indication of the vehicle ITS-S that
  /// * originate the CAM.
  /// *
  /// * @field vehicleWidth: This component represents the Vehicle Width of the vehicle ITS-S that originates the CAM excluding side mirrors and possible
  /// * similar extensions.
  /// *
  /// * @field longitudinalAcceleration: It represent the vehicle Longitudinal Acceleration of the originating ITS-S in the centre of the mass of the
  /// * empty vehicle. It shall include the measured vehicle longitudinal acceleration and its accuracy value with the confidence level of 95 %.
  /// * Otherwise, the longitudinalAccelerationConfidence shall be set to unavailable.
  /// *
  /// * @field curvature: this component reppresent the actual trajectory of the vehicle.
  /// *
  /// * @field curvatureCalculationMode: It indicates whether vehicle yaw-rate is used in the calculation of the curvature of the vehicle ITS-S that
  /// * originates the CAM.
  /// *
  /// * @field yawRate: It denotes the vehicle rotation around the centre of mass of the empty vehicle. The leading sign denotes the direction of
  /// * rotation. The value is negative if the motion is clockwise when viewing from the top.
  /// * yawRateConfidence denotes the accuracy for the 95 % confidence level for the measured yawRateValue. Otherwise, the value of yawRateConfidence
  /// * shall be set to unavailable.
  /// *
  /// * @field accelerationControl: an optional component which represents the current status of the vehcile mechnanisms controlling the longitudinal movement of the vehcile ITS-S
  /// * (e.g. brake pedal,  gas pedal, etc. engaged) that originate the CAM.
  /// *
  /// * @field lanePosition: an optional component which represents the lanePosition of the referencePosition of a vehicle. This component shall be present if the data is
  /// * available at the originating ITS-S.
  /// *
  /// * @field steeringWheelAngle: an optional component which indicates the steering wheel angle and accuracy as measured at the vehicle ITS-S that originates the CAM.
  /// *
  /// * @field lateralAcceleration: an optional component which represents the vehicle lateral acceleration of the originating ITS-S in the centre of the mass of the empty vehicle.
  /// * It shall include the measured vehicle lateral acceleration and its accuracy value with the confidence level of 95%.
  /// *
  /// * @field verticalAcceleration: an optional component which indicates the originating ITS-S in the centre of the mass of the empty vehicle.
  /// *
  /// * @field performanceClass: an optional component characterizes the maximum age of the CAM data elements with regard to the generation delta time.
  /// *
  /// * @field cenDsrcTollingZone: an optional component which represents the information about the position of a CEN DSRC Tolling Station operating in the 5,8 GHz frequency band.
  /// */
  /// BasicVehicleContainerHighFrequency ::= SEQUENCE {
  ///  heading Heading,
  ///  speed Speed,
  ///  driveDirection DriveDirection,
  ///  vehicleLength VehicleLength,
  ///  vehicleWidth VehicleWidth,
  ///  longitudinalAcceleration AccelerationComponent,
  ///  curvature Curvature,
  ///  curvatureCalculationMode CurvatureCalculationMode,
  ///  yawRate YawRate,
  ///  accelerationControl AccelerationControl OPTIONAL,
  ///  lanePosition LanePosition OPTIONAL,
  ///  steeringWheelAngle SteeringWheelAngle OPTIONAL,
  ///  lateralAcceleration AccelerationComponent OPTIONAL,
  ///  verticalAcceleration AccelerationComponent OPTIONAL,
  ///  performanceClass PerformanceClass OPTIONAL,
  ///  cenDsrcTollingZone CenDsrcTollingZone OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__Heading heading;
  etsi_its_cam_ts_msgs__msg__Speed speed;
  etsi_its_cam_ts_msgs__msg__DriveDirection drive_direction;
  etsi_its_cam_ts_msgs__msg__VehicleLength vehicle_length;
  etsi_its_cam_ts_msgs__msg__VehicleWidth vehicle_width;
  etsi_its_cam_ts_msgs__msg__AccelerationComponent longitudinal_acceleration;
  etsi_its_cam_ts_msgs__msg__Curvature curvature;
  etsi_its_cam_ts_msgs__msg__CurvatureCalculationMode curvature_calculation_mode;
  etsi_its_cam_ts_msgs__msg__YawRate yaw_rate;
  etsi_its_cam_ts_msgs__msg__AccelerationControl acceleration_control;
  bool acceleration_control_is_present;
  etsi_its_cam_ts_msgs__msg__LanePosition lane_position;
  bool lane_position_is_present;
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngle steering_wheel_angle;
  bool steering_wheel_angle_is_present;
  etsi_its_cam_ts_msgs__msg__AccelerationComponent lateral_acceleration;
  bool lateral_acceleration_is_present;
  etsi_its_cam_ts_msgs__msg__AccelerationComponent vertical_acceleration;
  bool vertical_acceleration_is_present;
  etsi_its_cam_ts_msgs__msg__PerformanceClass performance_class;
  bool performance_class_is_present;
  etsi_its_cam_ts_msgs__msg__CenDsrcTollingZone cen_dsrc_tolling_zone;
  bool cen_dsrc_tolling_zone_is_present;
} etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency.
typedef struct etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency__Sequence
{
  etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_
