// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ClosedLanes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'innerhard_shoulder_status'
// Member 'outerhard_shoulder_status'
#include "etsi_its_cam_ts_msgs/msg/detail/hard_shoulder_status__struct.h"
// Member 'driving_lane_status'
#include "etsi_its_cam_ts_msgs/msg/detail/driving_lane_status__struct.h"

/// Struct defined in msg/ClosedLanes in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ClosedLanes
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF indicates the opening/closure status of the lanes of a carriageway.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field innerhardShoulderStatus: this information is optional and shall be included if an inner hard shoulder is present and the information is known.
  ///  * It indicates the open/closing status of inner hard shoulder lanes.
  ///  *
  ///  * @field outerhardShoulderStatus: this information is optional and shall be included if an outer hard shoulder is present and the information is known.
  ///  * It indicates the open/closing status of outer hard shoulder lanes.
  ///  *
  ///  * @field drivingLaneStatus: this information is optional and shall be included if the information is known.
  ///  * It indicates the open/closing status of driving lanes.
  ///  * For carriageways with more than 13 driving lanes, the drivingLaneStatus component shall not be present.
  ///  *
  ///  * @category: Infrastructure information, Road topology information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// ClosedLanes ::= SEQUENCE {
  ///     innerhardShoulderStatus    HardShoulderStatus OPTIONAL,
  ///     outerhardShoulderStatus    HardShoulderStatus OPTIONAL,
  ///     drivingLaneStatus          DrivingLaneStatus OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__HardShoulderStatus innerhard_shoulder_status;
  bool innerhard_shoulder_status_is_present;
  etsi_its_cam_ts_msgs__msg__HardShoulderStatus outerhard_shoulder_status;
  bool outerhard_shoulder_status_is_present;
  etsi_its_cam_ts_msgs__msg__DrivingLaneStatus driving_lane_status;
  bool driving_lane_status_is_present;
} etsi_its_cam_ts_msgs__msg__ClosedLanes;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ClosedLanes.
typedef struct etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence
{
  etsi_its_cam_ts_msgs__msg__ClosedLanes * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_H_
