// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/CurvatureConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'ONE_PER_METER_0_00002'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_00002 = 0
};

/// Constant 'ONE_PER_METER_0_0001'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_0001 = 1
};

/// Constant 'ONE_PER_METER_0_0005'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_0005 = 2
};

/// Constant 'ONE_PER_METER_0_002'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_002 = 3
};

/// Constant 'ONE_PER_METER_0_01'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_01 = 4
};

/// Constant 'ONE_PER_METER_0_1'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__ONE_PER_METER_0_1 = 5
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__OUT_OF_RANGE = 6
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence__UNAVAILABLE = 7
};

/// Struct defined in msg/CurvatureConfidence in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__CurvatureConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.
  ///  * If required, the confidence level can be defined by the corresponding standards applying this DE.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,
  ///  * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,
  ///  * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,
  ///  * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,
  ///  * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,
  ///  * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,
  ///  * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,
  ///  * - 7 - `unavailable`         - if the confidence value is not available.
  ///  *
  ///  * @note: The fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by
  ///  * several reasons, such as:
  ///  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
  ///  * - the sensor cannot calculate the accuracy due to lack of variables, or
  ///  * - there has been a vehicle bus (e.g. CAN bus) error.
  ///  * In all 3 cases above, the curvature value may be valid and used by the application.
  ///  *
  ///  * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid
  ///  * and therefore cannot be trusted. Such value is not useful for the application.
  ///  *
  ///  * @category: Vehicle information
  ///  * @revision: Description revised in V2.1.1
  /// */
  /// CurvatureConfidence ::= ENUMERATED {
  ///     onePerMeter-0-00002 (0),
  ///     onePerMeter-0-0001  (1),
  ///     onePerMeter-0-0005  (2),
  ///     onePerMeter-0-002   (3),
  ///     onePerMeter-0-01    (4),
  ///     onePerMeter-0-1     (5),
  ///     outOfRange          (6),
  ///     unavailable         (7)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__CurvatureConfidence;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__CurvatureConfidence.
typedef struct etsi_its_cam_ts_msgs__msg__CurvatureConfidence__Sequence
{
  etsi_its_cam_ts_msgs__msg__CurvatureConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__CurvatureConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_CONFIDENCE__STRUCT_H_
