// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/CurvatureValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__MIN = -1023
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__MAX = 1023
};

/// Constant 'OUT_OF_RANGE_NEGATIVE'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__OUT_OF_RANGE_NEGATIVE = -1023
};

/// Constant 'STRAIGHT'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__STRAIGHT = 0
};

/// Constant 'OUT_OF_RANGE_POSITIVE'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__OUT_OF_RANGE_POSITIVE = 1022
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue__UNAVAILABLE = 1023
};

/// Struct defined in msg/CurvatureValue in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__CurvatureValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE describes vehicle turning curve with the following information:
  ///  * ```
  ///  *     Value = 1 / Radius * 10000
  ///  * ```
  ///  * wherein radius is the vehicle turning curve radius in metres.
  ///  *
  ///  * Positive values indicate a turning curve to the left hand side of the driver.
  ///  * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].
  ///  *
  ///  * The value shall be set to:
  ///  * - `-1023` for  values smaller than -1023,
  ///  * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,
  ///  * - `0` when the vehicle is moving straight,
  ///  * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,
  ///  * - `1022`, for values  greater than 1021,
  ///  * - `1023`, if the information is not available.
  ///  *
  ///  * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].
  ///  *
  ///  * @unit: 1 over 10 000 metres
  ///  * @category: Vehicle information
  ///  * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)
  ///  */
  /// CurvatureValue ::= INTEGER {
  ///     outOfRangeNegative (-1023),
  ///     straight           (0),
  ///     outOfRangePositive (1022),
  ///     unavailable        (1023)
  /// } (-1023..1023)
  /// ------------------------------------------------------------------------------
  int16_t value;
} etsi_its_cam_ts_msgs__msg__CurvatureValue;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__CurvatureValue.
typedef struct etsi_its_cam_ts_msgs__msg__CurvatureValue__Sequence
{
  etsi_its_cam_ts_msgs__msg__CurvatureValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__CurvatureValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE_VALUE__STRUCT_H_
