// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/DeltaLatitude.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_LATITUDE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_LATITUDE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__DeltaLatitude__MIN = -131071l
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__DeltaLatitude__MAX = 131072l
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DeltaLatitude__UNAVAILABLE = 131072l
};

/// Struct defined in msg/DeltaLatitude in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__DeltaLatitude
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents an offset latitude with regards to a defined latitude value.
  ///  * It may be used to describe a geographical point with regards to a specific reference geographical position.
  ///  *
  ///  * The value shall be set to:
  ///  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
  ///  * - `0` for no latitudinal offset,
  ///  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
  ///  * - `131 072` when the information is unavailable.
  ///  *
  ///  * @unit: 10^-7 degree
  ///  * @category: GeoReference information
  ///  * @revision: editorial update in V2.1.1
  ///  */
  /// DeltaLatitude ::= INTEGER {
  ///     unavailable (131072)
  /// } (-131071..131072)
  /// ------------------------------------------------------------------------------
  int32_t value;
} etsi_its_cam_ts_msgs__msg__DeltaLatitude;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__DeltaLatitude.
typedef struct etsi_its_cam_ts_msgs__msg__DeltaLatitude__Sequence
{
  etsi_its_cam_ts_msgs__msg__DeltaLatitude * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__DeltaLatitude__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_LATITUDE__STRUCT_H_
