// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/EmergencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__struct.h"
// Member 'incident_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__struct.h"
// Member 'emergency_priority'
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_priority__struct.h"

/// Struct defined in msg/EmergencyContainer in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__EmergencyContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  /// * This type contains detaild information of the Emergency Container.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
  /// *
  /// * @field incidentIndication: the optional incident related to the roadworks to provide additional information of the roadworks zone.
  /// *
  /// * @field emergencyPriority: the optional component represent right of way indicator of the vehicle ITS-S that originates the CAM PDU.
  /// */
  /// EmergencyContainer ::= SEQUENCE {
  ///  lightBarSirenInUse LightBarSirenInUse,
  ///  incidentIndication CauseCodeV2 OPTIONAL,
  ///  emergencyPriority EmergencyPriority OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__LightBarSirenInUse light_bar_siren_in_use;
  etsi_its_cam_ts_msgs__msg__CauseCodeV2 incident_indication;
  bool incident_indication_is_present;
  etsi_its_cam_ts_msgs__msg__EmergencyPriority emergency_priority;
  bool emergency_priority_is_present;
} etsi_its_cam_ts_msgs__msg__EmergencyContainer;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__EmergencyContainer.
typedef struct etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence
{
  etsi_its_cam_ts_msgs__msg__EmergencyContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__STRUCT_H_
