// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ExteriorLights.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EXTERIOR_LIGHTS__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EXTERIOR_LIGHTS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__SIZE_BITS = 8
};

/// Constant 'BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
};

/// Constant 'BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
};

/// Constant 'BIT_INDEX_LEFT_TURN_SIGNAL_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
};

/// Constant 'BIT_INDEX_RIGHT_TURN_SIGNAL_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
};

/// Constant 'BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
};

/// Constant 'BIT_INDEX_REVERSE_LIGHT_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_REVERSE_LIGHT_ON = 5
};

/// Constant 'BIT_INDEX_FOG_LIGHT_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_FOG_LIGHT_ON = 6
};

/// Constant 'BIT_INDEX_PARKING_LIGHTS_ON'.
enum
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights__BIT_INDEX_PARKING_LIGHTS_ON = 7
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/ExteriorLights in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ExteriorLights
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
  ///  * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
  ///  * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
  ///  * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
  ///  * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
  ///  * - 5 - `reverseLightOn`         - when the reverse light switch is on,
  ///  * - 6 - `fogLightOn`             - when the tail fog light switch is on,
  ///  * - 7 - `parkingLightsOn`        - when the parking light switch is on.
  ///  *
  ///  * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
  ///  * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
  ///  * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
  ///  * if the corresponding lamps are alight or not.
  ///  *
  ///  * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
  ///  * the corresponding bit shall be set to `0`.
  ///  *
  ///  * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
  ///  * alternate with the blinking interval.
  ///  *
  ///  * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
  ///  *
  ///  * @category Vehicle information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// ExteriorLights ::= BIT STRING {
  ///     lowBeamHeadlightsOn      (0),
  ///     highBeamHeadlightsOn     (1),
  ///     leftTurnSignalOn         (2),
  ///     rightTurnSignalOn        (3),
  ///     daytimeRunningLightsOn   (4),
  ///     reverseLightOn           (5),
  ///     fogLightOn               (6),
  ///     parkingLightsOn          (7)
  /// } (SIZE(8))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cam_ts_msgs__msg__ExteriorLights;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ExteriorLights.
typedef struct etsi_its_cam_ts_msgs__msg__ExteriorLights__Sequence
{
  etsi_its_cam_ts_msgs__msg__ExteriorLights * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ExteriorLights__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EXTERIOR_LIGHTS__STRUCT_H_
