// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/PositionConfidenceEllipse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'semi_major_axis_length'
// Member 'semi_minor_axis_length'
#include "etsi_its_cam_ts_msgs/msg/detail/semi_axis_length__struct.h"
// Member 'semi_major_axis_orientation'
#include "etsi_its_cam_ts_msgs/msg/detail/wgs84_angle_value__struct.h"

/// Struct defined in msg/PositionConfidenceEllipse in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a
  ///  * confidence level of 95 %. The centre of the ellipse shape corresponds to the reference
  ///  * position point for which the position accuracy is evaluated.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field semiMajorAxisLength: half of length of the major axis, i.e. distance between the centre point
  ///  * and major axis point of the position accuracy ellipse.
  ///  *
  ///  * @field semiMinorAxisLength: half of length of the minor axis, i.e. distance between the centre point
  ///  * and minor axis point of the position accuracy ellipse.
  ///  *
  ///  * @field semiMajorAxisOrientation: orientation direction of the ellipse major axis of the position accuracy
  ///  * ellipse with regards to the WGS84 north.
  ///  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: created in V2.1.1 based on @ref PosConfidenceEllipse
  ///  */
  /// PositionConfidenceEllipse ::= SEQUENCE {
  ///     semiMajorAxisLength         SemiAxisLength,
  ///     semiMinorAxisLength         SemiAxisLength,
  ///     semiMajorAxisOrientation    Wgs84AngleValue
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__SemiAxisLength semi_major_axis_length;
  etsi_its_cam_ts_msgs__msg__SemiAxisLength semi_minor_axis_length;
  etsi_its_cam_ts_msgs__msg__Wgs84AngleValue semi_major_axis_orientation;
} etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse.
typedef struct etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence
{
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_H_
