// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ProtectedCommunicationZone.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'protected_zone_type'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_type__struct.h"
// Member 'expiry_time'
#include "etsi_its_cam_ts_msgs/msg/detail/timestamp_its__struct.h"
// Member 'protected_zone_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__struct.h"
// Member 'protected_zone_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__struct.h"
// Member 'protected_zone_radius'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_radius__struct.h"
// Member 'protected_zone_id'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__struct.h"

/// Struct defined in msg/ProtectedCommunicationZone in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF describes a zone of protection inside which the ITS communication should be restricted.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field protectedZoneType: type of the protected zone.
  ///  *
  ///  * @field expiryTime: optional time at which the validity of the protected communication zone will expire.
  ///  *
  ///  * @field protectedZoneLatitude: latitude of the centre point of the protected communication zone.
  ///  *
  ///  * @field protectedZoneLongitude: longitude of the centre point of the protected communication zone.
  ///  *
  ///  * @field protectedZoneRadius: optional radius of the protected communication zone in metres.
  ///  *
  ///  * @field protectedZoneId: the optional ID of the protected communication zone.
  ///  *
  ///  * @note: A protected communication zone may be defined around a CEN DSRC road side equipment.
  ///  *
  ///  * @category: Infrastructure information, Communication information
  ///  * @revision: revised in V2.1.1 (changed protectedZoneID to protectedZoneId)
  ///  */
  /// ProtectedCommunicationZone ::= SEQUENCE {
  ///     protectedZoneType         ProtectedZoneType,
  ///     expiryTime                TimestampIts OPTIONAL,
  ///     protectedZoneLatitude     Latitude,
  ///     protectedZoneLongitude    Longitude,
  ///     protectedZoneRadius       ProtectedZoneRadius OPTIONAL,
  ///     protectedZoneId           ProtectedZoneId OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__ProtectedZoneType protected_zone_type;
  etsi_its_cam_ts_msgs__msg__TimestampIts expiry_time;
  bool expiry_time_is_present;
  etsi_its_cam_ts_msgs__msg__Latitude protected_zone_latitude;
  etsi_its_cam_ts_msgs__msg__Longitude protected_zone_longitude;
  etsi_its_cam_ts_msgs__msg__ProtectedZoneRadius protected_zone_radius;
  bool protected_zone_radius_is_present;
  etsi_its_cam_ts_msgs__msg__ProtectedZoneId protected_zone_id;
  bool protected_zone_id_is_present;
} etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone.
typedef struct etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence
{
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_H_
