// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/PtActivation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pt_activation_type'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation_type__struct.h"
// Member 'pt_activation_data'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation_data__struct.h"

/// Struct defined in msg/PtActivation in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__PtActivation
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents activation data for real-time systems designed for operations control, traffic light priorities, track switches, barriers, etc.
  ///  * using a range of activation devices equipped in public transport vehicles.
  ///  *
  ///  * The activation of the corresponding equipment is triggered by the approach or passage of a public transport
  ///  * vehicle at a certain point (e.g. a beacon).
  ///  *
  ///  * @field ptActivationType: type of activation.
  ///  *
  ///  * @field ptActicationData: data of activation.
  ///  *
  ///  * Today there are different payload variants defined for public transport activation-data. The R09.x is one of
  ///  * the industry standard used by public transport vehicles (e.g. buses, trams) in Europe (e.g. Germany Austria)
  ///  * for controlling traffic lights, barriers, bollards, etc. This DF shall include information like route, course,
  ///  * destination, priority, etc.
  ///  *
  ///  * The R09.x content is defined in VDV recommendation 420. It includes following information:
  ///  * - Priority Request Information (pre-request, request, ready to start)
  ///  * - End of Prioritization procedure
  ///  * - Priority request direction
  ///  * - Public Transport line number
  ///  * - Priority of public transport
  ///  * - Route line identifier of the public transport
  ///  * - Route number identification
  ///  * - Destination of public transport vehicle
  ///  *
  ///  * Other countries may use different message sets defined by the local administration.
  ///  * @category: Vehicle information
  ///  * @revision: V1.3.1
  ///  */
  /// PtActivation ::= SEQUENCE {
  ///     ptActivationType    PtActivationType,
  ///     ptActivationData    PtActivationData
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__PtActivationType pt_activation_type;
  etsi_its_cam_ts_msgs__msg__PtActivationData pt_activation_data;
} etsi_its_cam_ts_msgs__msg__PtActivation;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__PtActivation.
typedef struct etsi_its_cam_ts_msgs__msg__PtActivation__Sequence
{
  etsi_its_cam_ts_msgs__msg__PtActivation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__PtActivation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_H_
