// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SlowVehicleSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SLOW_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SLOW_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'MAINTENANCE_VEHICLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__MAINTENANCE_VEHICLE = 1
};

/// Constant 'VEHICLES_SLOWING_TO_LOOK_AT_ACCIDENT'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__VEHICLES_SLOWING_TO_LOOK_AT_ACCIDENT = 2
};

/// Constant 'ABNORMAL_LOAD'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__ABNORMAL_LOAD = 3
};

/// Constant 'ABNORMAL_WIDE_LOAD'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__ABNORMAL_WIDE_LOAD = 4
};

/// Constant 'CONVOY'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__CONVOY = 5
};

/// Constant 'SNOWPLOUGH'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__SNOWPLOUGH = 6
};

/// Constant 'DEICING'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__DEICING = 7
};

/// Constant 'SALTING_VEHICLES'.
enum
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__SALTING_VEHICLES = 8
};

/// Struct defined in msg/SlowVehicleSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the sub cause codes of the @ref CauseCode "slowVehicle".
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`                    - in case further detailed information on slow vehicle driving event is
  ///  *                                        unavailable,
  ///  * - 1 `maintenanceVehicle`             - in case of a slow driving maintenance vehicle on the road,
  ///  * - 2 `vehiclesSlowingToLookAtAccident`- in case vehicle is temporally slowing down to look at accident, spot, etc.,
  ///  * - 3 `abnormalLoad`                   - in case an abnormal loaded vehicle is driving slowly on the road,
  ///  * - 4 `abnormalWideLoad`               - in case an abnormal wide load vehicle is driving slowly on the road,
  ///  * - 5 `convoy`                         - in case of slow driving convoy on the road,
  ///  * - 6 `snowplough`                     - in case of slow driving snow plough on the road,
  ///  * - 7 `deicing`                        - in case of slow driving de-icing vehicle on the road,
  ///  * - 8 `saltingVehicles`                - in case of slow driving salting vehicle on the road.
  ///  * - 9-255                              - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// SlowVehicleSubCauseCode ::= INTEGER {
  ///     unavailable                     (0),
  ///     maintenanceVehicle              (1),
  ///     vehiclesSlowingToLookAtAccident (2),
  ///     abnormalLoad                    (3),
  ///     abnormalWideLoad                (4),
  ///     convoy                          (5),
  ///     snowplough                      (6),
  ///     deicing                         (7),
  ///     saltingVehicles                 (8)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SlowVehicleSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SLOW_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_
