// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SpeedValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPEED_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPEED_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpeedValue__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpeedValue__MAX = 16383
};

/// Constant 'STANDSTILL'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpeedValue__STANDSTILL = 0
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpeedValue__OUT_OF_RANGE = 16382
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpeedValue__UNAVAILABLE = 16383
};

/// Struct defined in msg/SpeedValue in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SpeedValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents a speed value, i.e. the magnitude of the velocity-vector.
  ///  *
  ///  * The value shall be set to:
  ///  * - `0` in a standstill situation.
  ///  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
  ///  * - `16 382` for speed values greater than 163,81 m/s,
  ///  * - `16 383` if the speed accuracy information is not available.
  ///  *
  ///  * @note: the definition of standstill is out of scope of the present document.
  ///  *
  ///  * @unit: 0,01 m/s
  ///  * @category: Kinematic information
  ///  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly)
  /// */
  /// SpeedValue ::= INTEGER {
  ///     standstill  (0),
  ///     outOfRange  (16382),
  ///     unavailable (16383)
  /// } (0..16383)
  /// ------------------------------------------------------------------------------
  uint16_t value;
} etsi_its_cam_ts_msgs__msg__SpeedValue;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SpeedValue.
typedef struct etsi_its_cam_ts_msgs__msg__SpeedValue__Sequence
{
  etsi_its_cam_ts_msgs__msg__SpeedValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SpeedValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPEED_VALUE__STRUCT_H_
