// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/StationaryVehicleSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'HUMAN_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__HUMAN_PROBLEM = 1
};

/// Constant 'VEHICLE_BREAKDOWN'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__VEHICLE_BREAKDOWN = 2
};

/// Constant 'POST_CRASH'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__POST_CRASH = 3
};

/// Constant 'PUBLIC_TRANSPORT_STOP'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__PUBLIC_TRANSPORT_STOP = 4
};

/// Constant 'CARRYING_DANGEROUS_GOODS'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__CARRYING_DANGEROUS_GOODS = 5
};

/// Constant 'VEHICLE_ON_FIRE'.
enum
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__VEHICLE_ON_FIRE = 6
};

/// Struct defined in msg/StationaryVehicleSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE provides the value of the sub cause codes of the @ref CauseCode "stationaryVehicle".
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`           - in case further detailed information on stationary vehicle is unavailable,
  ///  * - 1 `humanProblem`          - in case stationary vehicle is due to health problem of driver or passenger,
  ///  * - 2 `vehicleBreakdown`      - in case stationary vehicle is due to vehicle break down,
  ///  * - 3 `postCrash`             - in case stationary vehicle is caused by collision,
  ///  * - 4 `publicTransportStop`   - in case public transport vehicle is stationary at bus stop,
  ///  * - 5 `carryingDangerousGoods`- in case the stationary vehicle is carrying dangerous goods,
  ///  * - 6 `vehicleOnFire`         - in case of vehicle on fire.
  ///  * - 7-255 reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// StationaryVehicleSubCauseCode ::= INTEGER {
  ///     unavailable            (0),
  ///     humanProblem           (1),
  ///     vehicleBreakdown       (2),
  ///     postCrash              (3),
  ///     publicTransportStop    (4),
  ///     carryingDangerousGoods (5),
  ///     vehicleOnFire          (6)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_SUB_CAUSE_CODE__STRUCT_H_
