// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SteeringWheelAngleConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__MAX = 127
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__OUT_OF_RANGE = 126
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__UNAVAILABLE = 127
};

/// Struct defined in msg/SteeringWheelAngleConfidence in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the steering wheel angle confidence value which represents the estimated absolute accuracy for a  steering wheel angle value with a confidence level of 95 %.
  ///  *
  ///  * The value shall be set to:
  ///  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 1,5 degrees,
  ///  * - `126` if the confidence value is out of range, i.e. greater than 187,5 degrees,
  ///  * - `127` if the confidence value is not available.
  ///  *
  ///  * @note: The fact that a steering wheel angle value is received with confidence value set to `unavailable(127)`
  ///  * can be caused by several reasons, such as:
  ///  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
  ///  * - the sensor cannot calculate the accuracy due to lack of variables, or
  ///  * - there has been a vehicle bus (e.g. CAN bus) error.
  ///  * In all 3 cases above, the steering wheel angle value may be valid and used by the application.
  ///  *
  ///  * If a steering wheel angle value is received and its confidence value is set to `outOfRange(126)`,
  ///  * it means that the steering wheel angle value is not valid and therefore cannot be trusted.
  ///  * Such value is not useful for the application.
  ///  *
  ///  * @unit: 1,5 degree
  ///  * @category: Vehicle Information
  ///  * @revision: Description revised in V2.1.1
  /// */
  /// SteeringWheelAngleConfidence ::= INTEGER {
  ///     outOfRange                      (126),
  ///     unavailable                     (127)
  /// } (1..127)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence.
typedef struct etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__Sequence
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SteeringWheelAngleConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_CONFIDENCE__STRUCT_H_
