// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SteeringWheelAngleValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__MIN = -511
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__MAX = 512
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__NEGATIVE_OUT_OF_RANGE = -511
};

/// Constant 'POSITIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__POSITIVE_OUT_OF_RANGE = 511
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__UNAVAILABLE = 512
};

/// Struct defined in msg/SteeringWheelAngleValue in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the steering wheel angle of the vehicle at certain point in time.
  ///  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855, clause 2.11.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-511` if the steering wheel angle is equal to or greater than 511 x 1,5 degrees = 766,5 degrees to the right,
  ///  * - `n` (`n > -511` and `n <= 0`) if  the steering wheel angle is equal to or less than n x 1,5 degrees, and greater than (n-1) x 1,5 degrees,
  ///       turning clockwise (i.e. to the right),
  ///  * - `n` (`n >= 1` and `n < 511`) if the steering wheel angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
  ///       turning counter-clockwise (i.e. to the left),
  ///  * - `511` if the steering wheel angle is greater than 510 x 1,5 degrees = 765 degrees to the left,
  ///  * - `512` if information is not available.
  ///  *
  ///  * @unit: 1,5 degree
  ///  * @revision: Description revised in V2.1.1 (meaning of value 511 has changed slightly).
  ///  */
  /// SteeringWheelAngleValue ::= INTEGER {
  ///     negativeOutOfRange (-511),
  ///     positiveOutOfRange (511),
  ///     unavailable        (512)
  /// } (-511..512)
  /// ------------------------------------------------------------------------------
  int16_t value;
} etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue.
typedef struct etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__Sequence
{
  etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SteeringWheelAngleValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE_VALUE__STRUCT_H_
