// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/TrafficParticipantType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_PARTICIPANT_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_PARTICIPANT_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__MAX = 255
};

/// Constant 'UNKNOWN'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__UNKNOWN = 0
};

/// Constant 'PEDESTRIAN'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__PEDESTRIAN = 1
};

/// Constant 'CYCLIST'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__CYCLIST = 2
};

/// Constant 'MOPED'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__MOPED = 3
};

/// Constant 'MOTORCYCLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__MOTORCYCLE = 4
};

/// Constant 'PASSENGER_CAR'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__PASSENGER_CAR = 5
};

/// Constant 'BUS'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__BUS = 6
};

/// Constant 'LIGHT_TRUCK'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__LIGHT_TRUCK = 7
};

/// Constant 'HEAVY_TRUCK'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__HEAVY_TRUCK = 8
};

/// Constant 'TRAILER'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__TRAILER = 9
};

/// Constant 'SPECIAL_VEHICLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__SPECIAL_VEHICLE = 10
};

/// Constant 'TRAM'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__TRAM = 11
};

/// Constant 'LIGHT_VRU_VEHICLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__LIGHT_VRU_VEHICLE = 12
};

/// Constant 'ANIMAL'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__ANIMAL = 13
};

/// Constant 'AGRICULTURAL'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__AGRICULTURAL = 14
};

/// Constant 'ROAD_SIDE_UNIT'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__ROAD_SIDE_UNIT = 15
};

/// Struct defined in msg/TrafficParticipantType in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__TrafficParticipantType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the type of a traffic participant.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unknown`          - information about traffic participant is not provided,
  ///  * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
  ///  * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
  ///  * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
  ///  * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
  ///  * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
  ///  * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
  ///  * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
  ///  * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
  ///  * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
  ///  * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
  ///  * - 11 `tram`            - vehicle which runs on tracks along public streets,
  ///  * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
  ///  * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
  ///  * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
  ///  * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole,
  ///                             on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
  ///  * - 16-255               - are reserved for future usage.
  ///  *
  ///  * @category: Communication information.
  ///  * @revision: Created in V2.1.1 based on StationType
  ///  */
  /// TrafficParticipantType ::= INTEGER {
  ///     unknown         (0),
  ///     pedestrian      (1),
  ///     cyclist         (2),
  ///     moped           (3),
  ///     motorcycle      (4),
  ///     passengerCar    (5),
  ///     bus             (6),
  ///     lightTruck      (7),
  ///     heavyTruck      (8),
  ///     trailer         (9),
  ///     specialVehicle  (10),
  ///     tram            (11),
  ///     lightVruVehicle (12),
  ///     animal          (13),
  ///     agricultural    (14),
  ///     roadSideUnit    (15)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__TrafficParticipantType;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__TrafficParticipantType.
typedef struct etsi_its_cam_ts_msgs__msg__TrafficParticipantType__Sequence
{
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__TrafficParticipantType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_PARTICIPANT_TYPE__STRUCT_H_
