// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleLengthConfidenceIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH_CONFIDENCE_INDICATION__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH_CONFIDENCE_INDICATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NO_TRAILER_PRESENT'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__NO_TRAILER_PRESENT = 0
};

/// Constant 'TRAILER_PRESENT_WITH_KNOWN_LENGTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__TRAILER_PRESENT_WITH_KNOWN_LENGTH = 1
};

/// Constant 'TRAILER_PRESENT_WITH_UNKNOWN_LENGTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__TRAILER_PRESENT_WITH_UNKNOWN_LENGTH = 2
};

/// Constant 'TRAILER_PRESENCE_IS_UNKNOWN'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__TRAILER_PRESENCE_IS_UNKNOWN = 3
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__UNAVAILABLE = 4
};

/// Struct defined in msg/VehicleLengthConfidenceIndication in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE provides information about the presence of a trailer.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `noTrailerPresent`                - to indicate that no trailer is present, i.e. either the vehicle is physically not enabled to tow a trailer or it has been detected that no trailer is present,
  ///  * - 1 `trailerPresentWithKnownLength`   - to indicate that a trailer has been detected as present and the length is  included in the vehicle length value,
  ///  * - 2 `trailerPresentWithUnknownLength` - to indicate that a trailer has been detected as present and the length is not included in the vehicle length value,
  ///  * - 3 `trailerPresenceIsUnknown`        - to indicate that information about the trailer presence is unknown, i.e. the vehicle is physically enabled to tow a trailer but the detection of trailer presence/absence is not possible,
  ///  * - 4 `unavailable`                     - to indicate that the information about the presence of a trailer is not available, i.e. it is neither known whether the vehicle is able to tow a trailer,
  ///  *                                        nor the detection of trailer presence/absence is possible.
  ///  *
  ///  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref TrailerPresenceInformation instead.
  ///  * @category: Vehicle information
  ///  * @revision: Description revised in V2.1.1
  /// */
  /// VehicleLengthConfidenceIndication ::= ENUMERATED {
  ///     noTrailerPresent                (0),
  ///     trailerPresentWithKnownLength   (1),
  ///     trailerPresentWithUnknownLength (2),
  ///     trailerPresenceIsUnknown        (3),
  ///     unavailable                     (4)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication.
typedef struct etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__Sequence
{
  etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__VehicleLengthConfidenceIndication__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH_CONFIDENCE_INDICATION__STRUCT_H_
