// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/YawRateConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DEG_SEC_000_01'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_000_01 = 0
};

/// Constant 'DEG_SEC_000_05'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_000_05 = 1
};

/// Constant 'DEG_SEC_000_10'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_000_10 = 2
};

/// Constant 'DEG_SEC_001_00'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_001_00 = 3
};

/// Constant 'DEG_SEC_005_00'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_005_00 = 4
};

/// Constant 'DEG_SEC_010_00'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_010_00 = 5
};

/// Constant 'DEG_SEC_100_00'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__DEG_SEC_100_00 = 6
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__OUT_OF_RANGE = 7
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence__UNAVAILABLE = 8
};

/// Struct defined in msg/YawRateConfidence in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__YawRateConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the yaw rate confidence value which represents the estimated accuracy for a yaw rate value with a default confidence level of 95 %.
  ///  * If required, the confidence level can be defined by the corresponding standards applying this DE.
  ///  *
  ///  * The value shall be set to:
  ///  * - `0` if the confidence value is equal to or less than 0,01 degree/second,
  ///  * - `1` if the confidence value is equal to or less than 0,05 degrees/second or greater than 0,01 degree/second,
  ///  * - `2` if the confidence value is equal to or less than 0,1 degree/second or greater than 0,05 degree/second,
  ///  * - `3` if the confidence value is equal to or less than 1 degree/second or greater than 0,1 degree/second,
  ///  * - `4` if the confidence value is equal to or less than 5 degrees/second or greater than 1 degrees/second,
  ///  * - `5` if the confidence value is equal to or less than 10 degrees/second or greater than 5 degrees/second,
  ///  * - `6` if the confidence value is equal to or less than 100 degrees/second or greater than 10 degrees/second,
  ///  * - `7` if the confidence value is out of range, i.e. greater than 100 degrees/second,
  ///  * - `8` if the confidence value is unavailable.
  ///  *
  ///  * NOTE: The fact that a yaw rate value is received with confidence value set to `unavailable(8)` can be caused by
  ///  * several reasons, such as:
  ///  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
  ///  * - the sensor cannot calculate the accuracy due to lack of variables, or
  ///  * - there has been a vehicle bus (e.g. CAN bus) error.
  ///  * In all 3 cases above, the yaw rate value may be valid and used by the application.
  ///  *
  ///  * If a yaw rate value is received and its confidence value is set to `outOfRange(7)`, it means that the
  ///  * yaw rate value is not valid and therefore cannot be trusted. Such value is not useful the application.
  ///  *
  ///  * @category: Vehicle information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// YawRateConfidence ::= ENUMERATED {
  ///     degSec-000-01 (0),
  ///     degSec-000-05 (1),
  ///     degSec-000-10 (2),
  ///     degSec-001-00 (3),
  ///     degSec-005-00 (4),
  ///     degSec-010-00 (5),
  ///     degSec-100-00 (6),
  ///     outOfRange    (7),
  ///     unavailable   (8)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__YawRateConfidence;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__YawRateConfidence.
typedef struct etsi_its_cam_ts_msgs__msg__YawRateConfidence__Sequence
{
  etsi_its_cam_ts_msgs__msg__YawRateConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__YawRateConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_CONFIDENCE__STRUCT_H_
