// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/YawRateValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateValue__MIN = -32766
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateValue__MAX = 32767
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateValue__NEGATIVE_OUT_OF_RANGE = -32766
};

/// Constant 'POSITIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateValue__POSITIVE_OUT_OF_RANGE = 32766
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__YawRateValue__UNAVAILABLE = 32767
};

/// Struct defined in msg/YawRateValue in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__YawRateValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the vehicle rotation around z-axis of the coordinate system centred on the centre of mass of the empty-loaded
  ///  * vehicle. The leading sign denotes the direction of rotation.
  ///  *
  ///  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-32 766` to indicate that the yaw rate is equal to or greater than 327,66 degrees/second to the right,
  ///  * - `n` (`n > -32 766` and `n <= 0`) to indicate that the rotation is clockwise (i.e. to the right) and is equal to or less than n x 0,01 degrees/s,
  ///       and greater than (n-1) x 0,01 degrees/s,
  ///  * - `n` (`n > 0` and `n < 32 766`) to indicate that the rotation is anti-clockwise (i.e. to the left) and is equal to or less than n x 0,01 degrees/s,
  ///       and greater than (n-1) x 0,01 degrees/s,
  ///  * - `32 766` to indicate that the yaw rate is greater than 327.65 degrees/second to the left,
  ///  * - `32 767` to indicate that the information is not available.
  ///  *
  ///  * The yaw rate value shall be a raw data value, i.e. not filtered, smoothed or otherwise modified.
  ///  * The reading instant should be the same as for the vehicle acceleration.
  ///  *
  ///  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
  ///  *
  ///  * @unit: 0,01 degree per second.
  ///  * @category: Vehicle Information
  ///  * @revision: Desription revised in V2.1.1 (the meaning of 32766 has changed slightly).
  /// */
  /// YawRateValue ::= INTEGER {
  ///     negativeOutOfRange (-32766),
  ///     positiveOutOfRange (32766),
  ///     unavailable        (32767)
  /// } (-32766..32767)
  /// ------------------------------------------------------------------------------
  int16_t value;
} etsi_its_cam_ts_msgs__msg__YawRateValue;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__YawRateValue.
typedef struct etsi_its_cam_ts_msgs__msg__YawRateValue__Sequence
{
  etsi_its_cam_ts_msgs__msg__YawRateValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__YawRateValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE_VALUE__STRUCT_H_
